package ve.gob.cnti.ciudadano.ejb;

import java.util.Map;
import java.util.logging.Logger;

import javax.ejb.ActivationConfigProperty;
import javax.ejb.MessageDriven;
import javax.jms.MapMessage;
import javax.jms.Message;
import javax.jms.MessageListener;

import ve.gob.cnti.ciudadano.jdbc.ConnectionJDBC;
import ve.gob.cnti.ciudadano.jdbc.IConnectionJDBC;
import ve.gob.cnti.ciudadano.utils.IMapMessageConverter;
import ve.gob.cnti.ciudadano.utils.MapMessageConverter;


/**
 * Message-Driven Bean implementation class for: CiudadanoEJB
 */
@MessageDriven(
		activationConfig = { @ActivationConfigProperty(
				propertyName = "destination", propertyValue = "jms/queue/ciudadano"), @ActivationConfigProperty(
				propertyName = "destinationType", propertyValue = "javax.jms.Queue")
		}, 
		mappedName = "jms/queue/ciudadano")
public class CiudadanoEJB implements MessageListener {
	private static final Logger log = Logger.getLogger(CiudadanoEJB.class.getName());
    /**
     * Default constructor. 
     */
    public CiudadanoEJB() {
        // TODO Auto-generated constructor stub
    }
	
	/**
     * @see MessageListener#onMessage(Message)
     */
    public void onMessage(Message message) {
        // TODO Auto-generated method stub
    	log.info("mensaje recibido en el portal ciudadano");
    	log.info("usando el ejb para ingresar las actividades en la bd del portal ciudadano");    	
		MapMessage incoming = (MapMessage)message;
		IConnectionJDBC connection=new ConnectionJDBC();		
		IMapMessageConverter converterMessage=new MapMessageConverter();
		Map<String,String> map=converterMessage.converMapMessageToMap(incoming);
		connection.insertRecord(map); 
		connection.closeConnection();
    	
        
    }

}
