package ve.gob.cnti.ciudadano.jdbc;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Map;
import java.util.logging.Logger;

import org.apache.commons.dbcp2.BasicDataSource;

import ve.gob.cnti.ciudadano.utils.ConverDate;
import ve.gob.cnti.ciudadano.utils.IConvertDate;
import ve.gob.cnti.ciudadano.utils.PropertiesReader;


/**
 * Esta clase se encarga de extraer informacion de la tabla arch_process_instance_lastupdate, process_instance y data_instance
 * para implementar esta clase utilice la clase CaseImpl.java
 * @author Yamil Orozco
 */

public class ConnectionJDBC implements IConnectionJDBC {
	
	Connection cnn=null;
	Statement ps = null;
    ResultSet rs=null;
    private static BasicDataSource basicDataSource=new BasicDataSource();   
    PropertiesReader properties = new PropertiesReader();		
    public String DATABASE_URL = properties.getProperty("DATABASE_URL");
    public String DATABASE_USER = properties.getProperty("DATABASE_USER");
    public String DATABASE_PASSWORD = properties.getProperty("DATABASE_PASSWORD");
    public Integer MAX_CONNECTION = Integer.valueOf(properties.getProperty("MAX_CONNECTION"));
    public Integer INITIAL_CONNECTION = Integer.valueOf(properties.getProperty("INITIAL_CONNECTION"));
    public Integer MAX_IDLE = Integer.valueOf(properties.getProperty("MAX_IDLE"));
    public Integer MIN_IDLE = Integer.valueOf(properties.getProperty("MIN_IDLE"));
    public Boolean REMOVE_ABANDONED = Boolean.valueOf(properties.getProperty("REMOVE_ABANDONED"));
    public Integer REMOVE_ABANDONED_TIME = Integer.valueOf(properties.getProperty("REMOVE_ABANDONED_TIME"));
    private static final Logger log = Logger.getLogger(ConnectionJDBC.class.getName());
    Boolean next=null;
    
    public ConnectionJDBC(){
    	
    	basicDataSource=new BasicDataSource();
		basicDataSource.setDriverClassName("org.postgresql.Driver");
		basicDataSource.setUrl(DATABASE_URL);
		basicDataSource.setUsername(DATABASE_USER);
		basicDataSource.setPassword(DATABASE_PASSWORD);
		basicDataSource.setMaxTotal(MAX_CONNECTION);
		basicDataSource.setInitialSize(INITIAL_CONNECTION);
		basicDataSource.setValidationQuery("select 1");
		basicDataSource.setRemoveAbandonedOnBorrow(REMOVE_ABANDONED);
		basicDataSource.setRemoveAbandonedTimeout(REMOVE_ABANDONED_TIME);
		basicDataSource.setMaxIdle(MAX_IDLE);
		basicDataSource.setMinIdle(MIN_IDLE);
    }
  
    
	public void openConnection(){	
	
		/*basicDataSource.setDriverClassName("org.postgresql.Driver");
		basicDataSource.setUrl(DATABASE_URL);
		basicDataSource.setUsername(DATABASE_USER);
		basicDataSource.setPassword(DATABASE_PASSWORD);
		basicDataSource.setMaxTotal(MAX_CONNECTION);
		basicDataSource.setInitialSize(INITIAL_CONNECTION);
		basicDataSource.setValidationQuery("select 1");
		
		
		try {
			cnn =basicDataSource.getConnection();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}*/
	}
	
	public void insertRecord(Map<String,String> variables){
		IConvertDate converter=new ConverDate();
		String query=null;	
		log.info("ingresando el registro de la actividad");
		try {
			String status="En Proceso";
			if("notificacion".equals(variables.get("taskName"))){
				status="Finalizado";
			}			
			cnn =basicDataSource.getConnection();
			ps=cnn.createStatement();
			query="insert into arch_activities_instance_hist values ('"+
			Long.parseLong(variables.get("id"))+"','"
		    +variables.get("taskId")+"','"
			+variables.get("processName")+"','"
			+variables.get("processDescription")+"','"
			+variables.get("taskName")+"','"
			+variables.get("taskDescription")+"','"
			+variables.get("cedula")+"','"			
			+converter.getFormattedLongDateDate("yyyy-MM-dd",variables.get("lastupdate"))+"','"
			+converter.getFormattedLongDateDate("yyyy-MM-dd",variables.get("f_solicitud"))+"','"
			+variables.get("revision")+"','"
			+status
			+"') ";
			ps.executeUpdate(query);			
			
			
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			this.closeConnection();
		}	  
		
		try {
			

			if(ps!=null) ps.close();
			if(cnn!=null) cnn.close();
		} catch (SQLException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		
		
		this.closeConnection();
		
		
	}

	public void closeConnection(){
		
		try {
			/*ps.close();
			cnn.close();	*/
			basicDataSource.close();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}


	
    
	

}
